## afdko 4.0.1+dfsg1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

project(afdko)

# set(CMAKE_VERBOSE_MAKEFILE ON)

# This matches the MSVC_RUNTIME_LIBRARY property in
# c/makeotf/source/CMakeLists.txt, which can theoretically be used to
# statically link the runtime on Windows. However, the neededruntime DLL
# seems to be present in Windows and setting this caused problems in testing.
# (Setting ANTLR4_WITH_STATIC_CRT below to ON may or may not fix the problem.)
# cmake_policy(SET CMP0091 NEW) # Style of MSVC runtime selection

# RelWithDebInfo builds an optimized binary but includes debugging symbols
# Other common possibilities are "Debug" and "Release"
if (NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING "Build type configuration" FORCE)
endif()
message(STATUS "Build type is ${CMAKE_BUILD_TYPE}")

set(CMAKE_CXX_STANDARD 11)

# scikit-build
if(SKBUILD)
    find_package(PythonExtensions REQUIRED)
endif()

list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

# Antlr 4 configuration

# This is an alternate way of supplying the Antlr 4 sources that will override
# the git clone of the tag listed below. This is especially useful if you
# encounter compiler problems and need to make small edits to compensate. Start
# with the Antlr project's sources, e.g.
# https://www.antlr.org/download/antlr4-cpp-runtime-4.9.3-source.zip
# set(ANTLR4_ZIP_REPOSITORY "/path_to_antlr4_archive/a4.zip")

add_definitions(-DANTLR4CPP_STATIC)
set(ANTLR4_WITH_STATIC_CRT OFF)
# 4.9.3 is the latest ANTLR4 version
set(ANTLR4_TAG tags/4.9.3)
include(ExternalAntlr4Cpp)


if (DEFINED ENV{FORCE_BUILD_LIBXML2})
    set(BUILD_STATIC_LIBXML2 TRUE)
else()
    FIND_PACKAGE(LibXml2)
    if (${LibXml2_FOUND})
        set(BUILD_STATIC_LIBXML2 FALSE)
    elseif (DEFINED ENV{FORCE_SYSTEM_LIBXML2})
        message(FATAL_ERROR "FORCE_SYSTEM_LIBXML2 set but LibXML2 not found")
    else()
        set(BUILD_STATIC_LIBXML2 TRUE)
    endif()
endif()

if (${BUILD_STATIC_LIBXML2})
    message(STATUS "LibXML2 not found or overridden -- will download and statically link")
    set(LIBXML2_TAG tags/v2.9.13)
    include(ExternalLibXML2)
    include_directories(${LIBXML2_STATIC_INCLUDE_DIR})
    set(NEED_LIBXML2_DEPEND TRUE)
    if (WIN32)
        set(CHOSEN_LIBXML2_LIBRARY ${LIBXML2_WIN_LIBRARIES})
    else()
        set(CHOSEN_LIBXML2_LIBRARY ${LIBXML2_NONWIN_LIBRARIES})
    endif()
else()
    include_directories(${LIBXML2_INCLUDE_DIR})
    set(NEED_LIBXML2_DEPEND FALSE)
    set(CHOSEN_LIBXML2_LIBRARY ${LIBXML2_LIBRARY})
endif()

# sanitizer support
# work around https://github.com/pypa/setuptools/issues/1928 with environment
# variable
if(DEFINED ENV{ADD_SANITIZER})
    set(ADD_SANITIZER "$ENV{ADD_SANITIZER}" CACHE STRING "Sanitizer type (\"none\" for no sanitizer")
else()
    set(ADD_SANITIZER "none" CACHE STRING "Sanitizer type (\"none\" for no sanitizer")
endif()
include(AddSanitizer)
add_sanitizer("${ADD_SANITIZER}")

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
# Ported from old build files, XXX not sure if all of these are needed
if(WIN32)
    add_compile_definitions(CTL_CDECL=__cdecl CDECL=__cdecl
        OS=os_windowsNT ISP=isp_i80486 _CRT_SECURE_NO_DEPRECATE
        $<$<CONFIG:Release>:NDEBUG>)
endif()

include(CheckLibraryExists)
CHECK_LIBRARY_EXISTS(m floor "" HAVE_M_LIB)

include(CTest)
include(AddAFDKOTests)

add_subdirectory(c/shared/source)
add_subdirectory(c/detype1/source)
add_subdirectory(c/mergefonts/source)
add_subdirectory(c/rotatefont/source)
add_subdirectory(c/sfntdiff/source)
add_subdirectory(c/sfntedit/source)
add_subdirectory(c/spot/source)
add_subdirectory(c/tx/source)
add_subdirectory(c/type1/source)
add_subdirectory(c/makeotf)

=== requirements.txt ===
# 'lxml' is not a primary requirement of afdko but it's listed here because
# we want to have control over the version and guarantee that the XML output
# of our tools is stable
# NOTE: hard-pinning (==) here gets relaxed to >= in setup.py
lxml==4.9.3
booleanOperations==0.9.0
defcon[lxml,pens]==0.10.3
fontMath==0.9.3
fontTools[unicode,woff,lxml,ufo]==4.43.0
tqdm==4.66.1
ufonormalizer==0.6.1
ufoProcessor==1.9.0

=== c/makeotf/CMakeLists.txt ===
include_directories(include resource ../shared/include)

add_subdirectory(lib)
add_subdirectory(source)

=== c/detype1/source/CMakeLists.txt ===
add_executable(detype1 detype1.c)
install(TARGETS detype1 DESTINATION bin)

=== c/makeotf/lib/CMakeLists.txt ===
include_directories(AFTER ../../shared/resource)

add_subdirectory(cffread)
add_subdirectory(pstoken)
add_subdirectory(typecomp)
add_subdirectory(hotconv)

=== c/makeotf/source/CMakeLists.txt ===
add_executable(makeotfexe main.cpp)

target_sources(makeotfexe PRIVATE
    cb.c
    cbpriv.c
    c_main.c
    fcdb.c
    file.c
    mac.c
    makeotflib.h
    cb.h
    cbpriv.h
    fcdb.h
    file.h
    lctype.h
    lerrno.h
    lstdio.h
    lstdlib.h
    lstring.h
    package.h
    systemspecific.h
)

target_link_libraries(makeotfexe PRIVATE ctutil dynarr hotconv makeotf_pstoken typecomp makeotf_cffread)

if (HAVE_M_LIB)
    target_link_libraries(makeotfexe PRIVATE m)
endif ()

target_link_libraries(makeotfexe PUBLIC ${CHOSEN_LIBXML2_LIBRARY})

target_compile_definitions(makeotfexe PRIVATE MAKEOTFLIB_EXPORTS=1)

# set_target_properties(makeotfexe PROPERTIES MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>")

install(TARGETS makeotfexe DESTINATION bin)

=== c/mergefonts/source/CMakeLists.txt ===
add_executable(mergefonts
    mergeFonts.c
    help.h
    options.h
    usage.h
)

target_include_directories(mergefonts PRIVATE ../../shared/include ../../shared/resource ../../shared/source/tx_shared)

target_link_libraries(mergefonts PUBLIC tx_shared)
target_link_libraries(mergefonts PUBLIC ${CHOSEN_LIBXML2_LIBRARY})

if (${NEED_LIBXML_DEPEND})
    add_dependencies(mergefonts ${LIBXML2_TARGET})
    target_compile_definitions(mergefonts PUBLIC -DLIBXML_STATIC)
endif()

install(TARGETS mergefonts DESTINATION bin)

=== c/rotatefont/source/CMakeLists.txt ===
add_executable(rotatefont
    rotateFont.c
    help.h
    options.h
    usage.h
)

target_include_directories(rotatefont PRIVATE ../../shared/include ../../shared/resource ../../shared/source/tx_shared)

target_link_libraries(rotatefont PUBLIC tx_shared)

target_link_libraries(rotatefont PUBLIC ${CHOSEN_LIBXML2_LIBRARY})

if (${NEED_LIBXML2_DEPEND})
    add_dependencies(rotatefont ${LIBXML2_TARGET})
    target_compile_definitions(rotatefont PUBLIC -DLIBXML_STATIC)
endif()

install(TARGETS rotatefont DESTINATION bin)

=== c/sfntdiff/source/CMakeLists.txt ===
add_executable(sfntdiff Dmain.c)

target_sources(sfntdiff PRIVATE
    Dda.c
    Dda.h
    Ddesc.c
    Ddesc.h
    Dfile.c
    Dfile.h
    Dglobal.c
    Dglobal.h
    Dhead.c
    Dhead.h
    Dname.c
    Dname.h
    Dopt.c
    Dopt.h
    Dpriv.c
    Dsfnt.c
    Dsfnt.h
    Dsys.c
    Dsys.h
    Dtto.c
    Dtto.h
    numtypes.h
)

target_include_directories(sfntdiff PRIVATE ../../spot/sfnt_includes ../../shared/include)
install(TARGETS sfntdiff DESTINATION bin)

=== c/sfntedit/source/CMakeLists.txt ===
add_executable(sfntedit main.c)

target_sources(sfntedit PRIVATE
    Eda.c
    Eda.h
    Efile.c
    Efile.h
    Eglobal.c
    Eglobal.h
    Emsgs.c
    Emsgs.h
    Esys.c
    Esys.h
    main.c
    otftableeditor.h
)

target_include_directories(sfntedit PRIVATE ../../spot/sfnt_includes ../../shared/include)
install(TARGETS sfntedit DESTINATION bin)

=== c/spot/source/CMakeLists.txt ===
add_executable(spot main.c)

target_sources(spot PRIVATE
    BASE.c
    BASE.h
    BBOX.c
    BBOX.h
    bitstr.h
    BLND.c
    BLND.h
    CFF_.c
    CFF_.h
    cffread.c
    cffread.h
    CID_.c
    CID_.h
    cmap.c
    cmap.h
    da.c
    da.h
    desc.c
    desc.h
    dictops.h
    dump.c
    dump.h
    EBLC.c
    EBLC.h
    ENCO.c
    ENCO.h
    excs0.h
    excs.h
    exenc0.h
    exenccd.h
    exsubcs0.h
    exsubcs.h
    fdsc.c
    fdsc.h
    feat.c
    feat.h
    file.c
    file.h
    FNAM.c
    FNAM.h
    fvar.c
    fvar.h
    gasp.c
    gasp.h
    GDEF.c
    GDEF.h
    global.c
    global.h
    GLOB.c
    GLOB.h
    glyf.c
    glyf.h
    GPOS.c
    GPOS.h
    GSUB.c
    GSUB.h
    hdmx.c
    hdmx.h
    head.c
    head.h
    HFMX.c
    HFMX.h
    hhea.c
    hhea.h
    hmtx.c
    hmtx.h
    isocs0.h
    isocs.h
    kern.c
    kern.h
    loca.c
    loca.h
    LTSH.c
    LTSH.h
    map.c
    map.h
    maxp.c
    maxp.h
    META.c
    META.h
    MMFX.c
    MMFX.h
    MMSD.c
    MMSD.h
    MMVR.c
    MMVR.h
    name.c
    name.h
    nicename.h
    numtypes.h
    opt.c
    opt.h
    OS_2.c
    OS_2.h
    package.h
    pathbuild.c
    pathbuild.h
    post.c
    post.h
    proof.c
    proof.h
    res.c
    res.h
    sfnt.c
    sfnt.h
    SING.c
    SING.h
    spot.h
    spotmsgs.c
    spotmsgs.h
    stdenc0.h
    stdenccd.h
    stdstr1.h
    stdstr.h
    strftime.c
    sys.c
    sys.h
    trak.c
    trak.h
    TTdumpinstrs.c
    TTdumpinstrs.h
    tto.c
    tto.h
    txops.h
    TYP1.c
    TYP1.h
    vhea.c
    vhea.h
    vmtx.c
    vmtx.h
    VORG.c
    VORG.h
    WDTH.c
    WDTH.h
)

target_include_directories(spot PRIVATE ../../spot/sfnt_includes ../../shared/include .)
if(HAVE_M_LIB)
    target_link_libraries(spot PRIVATE m)
endif()
target_compile_definitions(spot PRIVATE EXECUTABLE=1)
install(TARGETS spot DESTINATION bin)

=== c/type1/source/CMakeLists.txt ===
add_executable(type1 type1.c)
install(TARGETS type1 DESTINATION bin)
if(WIN32)
    # Could be non-msvc compiler on windows
    target_compile_definitions(type1 PRIVATE _MSC_VER)
endif()

=== debian/changelog ===
afdko (4.0.1+dfsg1-2build2) questing; urgency=medium

  * No-change rebuild for libxml2 soname change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 26 May 2025 14:23:58 +0200

afdko (4.0.1+dfsg1-2build1) questing; urgency=medium

  * No-change rebuild for libxml2 soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 20 May 2025 12:23:57 +0200

afdko (4.0.1+dfsg1-2) unstable; urgency=medium

  * Team upload.
  * Source-only upload to allow testing migration.
  * Rebuild against GCC 14. (Closes: #1074802)
  * debian/control: Use dh-sequence-python3 to replace dh-python.

 -- Boyuan Yang <byang@debian.org>  Fri, 26 Jul 2024 09:02:06 -0400

afdko (4.0.1+dfsg1-1) unstable; urgency=medium

  [ Blair Noctis ]
  * Team upload.
  * New upstream version 4.0.1+dfsg1 (Closes: #1076611)
  * d/afdko.install:
    - Install 2 new programs, otfautohint and otfstemhist
  * d/control:
    - Add dependency libxml2-dev
  * d/rules:
    - Set FORCE_SYSTEM_LIBXML2 for cmake in dh_auto_build
    - Clean .eggs, _skbuild/
  * d/watch:
    - Update search rule (Closes: #1043455, thanks to anonymous contributor)
  * d/patches:
    - Add fix-escape-syntax-warning.patch

  [ Yao Wei (魏銘廷) ]
  * New upstream version 3.7.0~a9+dfsg1
  * d/rules:
    - Rebuild generated files under c/makeotf/lib/hotconv
    - Strip tilde in python version number
  * d/patches:
    - Use system libantlr4
    - Remove patches adding CPPFLAGS. Upstream migrated to cmake.
  * d/copyright: Add ANTLR4 copyright information
  * d/control: Add dependencies due to ANTLR4 addition

 -- Blair Noctis <n@sail.ng>  Fri, 26 Jul 2024 14:05:43 +0900

=== debian/control ===
Source: afdko
Section: devel
Priority: optional
Maintainer: Debian Fonts Task Force <debian-fonts@lists.debian.org>
Uploaders: Yao Wei (魏銘廷) <mwei@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 dh-sequence-python3,
 python3-all,
 python3-booleanoperations (>= 0.9.0),
 python3-defcon (>= 0.7.2),
 python3-fontmath (>= 0.6.0),
 python3-fonttools (>= 4.21.1),
 python3-psautohint (>= 2.3.0),
 python3-tqdm (>= 4.57.0),
 python3-ufonormalizer (>= 0.5.3),
 python3-ufoprocessor (>= 1.9.0),
 python3-setuptools,
 python3-setuptools-scm,
 python3-skbuild,
 python3-pip,
 libantlr4-runtime-dev,
 libxml2-dev,
 cmake,
 ninja-build,
 antlr4,
 python3-wheel
Standards-Version: 4.5.1
Homepage: https://adobe-type-tools.github.io/afdko/
Vcs-Browser: https://salsa.debian.org/fonts-team/afdko
Vcs-Git: https://salsa.debian.org/fonts-team/afdko.git
Testsuite: autopkgtest-pkg-python

Package: afdko
Architecture: all
Depends:
 ${shlibs:Depends}, ${misc:Depends},
 python3, python3-afdko (= ${source:Version})
Suggests: afdko-doc
Description: Adobe Font Development Kit for OpenType
 Tools used to make OpenType fonts by adding the OpenType-specific data to a
 TrueType or Type1 font.

Package: afdko-bin
Architecture: any
Depends:
 ${shlibs:Depends}, ${misc:Depends}
Description: Adobe Font Development Kit for OpenType (Binaries)
 Tools used to make OpenType fonts by adding the OpenType-specific data to a
 TrueType or Type1 font.
 .
 This package installs native binaries in AFDKO.

Package: python3-afdko
Architecture: all
Section: python
Depends:
 ${python3:Depends}, ${misc:Depends},
 afdko-bin (>= ${source:Version}),
 afdko-bin (<< ${source:Upstream-Version}.0~),
 python3-fontpens
Suggests: afdko-doc
Description: Adobe Font Development Kit for OpenType (Python 3)
 Tools used to make OpenType fonts by adding the OpenType-specific data to a
 TrueType or Type1 font.
 .
 This package installs the library for Python 3.

Package: afdko-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: Adobe Font Development Kit for OpenType (common documentation)
 Tools used to make OpenType fonts by adding the OpenType-specific data to a
 TrueType or Type1 font.
 .
 This is the common documentation package.
